"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var rtc_1 = require("./src/config/rtc");
var socket_message_1 = require("./src/constants/socket-message");
function useRTC(_a) {
    var _this = this;
    var socket = _a.socket, participants = _a.participants, setParticipants = _a.setParticipants;
    var myStreamRef = (0, react_1.useRef)(null);
    var myVideoRef = (0, react_1.useRef)(null);
    var peerConnectionRef = (0, react_1.useRef)(null);
    var setMyStream = function () { return __awaiter(_this, void 0, void 0, function () {
        var stream;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, navigator.mediaDevices.getUserMedia({
                        video: true,
                    })];
                case 1:
                    stream = _a.sent();
                    myStreamRef.current = stream;
                    if (myVideoRef.current) {
                        myVideoRef.current.srcObject = myStreamRef.current;
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    /**
     * Peer와 연결하기
     * @param peerId 연결할 피어의 Id
     * @returns 새로 생성한 peerConnection 객체
     */
    var setPeerConnection = function (peerId) {
        var _a;
        var peerConnection = new RTCPeerConnection(rtc_1.peerConnectionConfig);
        /* 이벤트 핸들러: Peer에게 candidate를 전달 할 필요가 있을때 마다 발생 */
        peerConnection.addEventListener("icecandidate", function (e) {
            socket.emit(socket_message_1.RTC_MESSAGE.ICE_CANDIDATE, {
                receiveId: peerId,
                candidate: e.candidate,
            });
        });
        /* 이벤트 핸들러: peerConnection에 새로운 트랙이 추가됐을 경우 호출됨 */
        peerConnection.addEventListener("track", function (e) {
            if (participants.has(peerId)) {
                return;
            }
            var peerStream = e.streams[0];
            // 새로운 peer를 참여자에 추가
            setParticipants(function (prev) {
                var newState = new Map(prev);
                newState.set(peerId, peerStream);
                return newState;
            });
        });
        (_a = myStreamRef.current) === null || _a === void 0 ? void 0 : _a.getTracks().forEach(function (track) {
            if (!myStreamRef.current)
                return;
            // 다른 유저에게 전달해주기 위해 내 미디어를 peerConnection 에 추가한다.
            // track이 myStreamRef.current(내 스트림)에 추가됨
            peerConnection.addTrack(track, myStreamRef.current);
        });
        return peerConnection;
    };
    (0, react_1.useEffect)(function () {
        setMyStream();
        /* 유저 join */
        socket.emit(socket_message_1.RTC_MESSAGE.JOIN);
        /* 새로 들어온 유저의 socketId를 받음 */
        socket.on(socket_message_1.RTC_MESSAGE.JOIN, function (socketId) { return __awaiter(_this, void 0, void 0, function () {
            var peerConnection, offer;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        peerConnection = setPeerConnection(socketId);
                        peerConnectionRef.current = __assign(__assign({}, peerConnectionRef.current), (_a = {}, _a[socketId] = peerConnection, _a));
                        return [4 /*yield*/, peerConnection.createOffer()];
                    case 1:
                        offer = _b.sent();
                        return [4 /*yield*/, peerConnection.setLocalDescription(offer)];
                    case 2:
                        _b.sent();
                        socket.emit(socket_message_1.RTC_MESSAGE.OFFER, {
                            receiveId: socketId,
                            offer: offer,
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        /* offer 받기 */
        socket.on(socket_message_1.RTC_MESSAGE.OFFER, function (_a) {
            var senderId = _a.senderId, offer = _a.offer;
            return __awaiter(_this, void 0, void 0, function () {
                var peerConnection, answer;
                var _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            peerConnection = setPeerConnection(senderId);
                            peerConnectionRef.current = __assign(__assign({}, peerConnectionRef.current), (_b = {}, _b[senderId] = peerConnection, _b));
                            return [4 /*yield*/, peerConnection.setRemoteDescription(offer)];
                        case 1:
                            _c.sent();
                            return [4 /*yield*/, peerConnection.createAnswer()];
                        case 2:
                            answer = _c.sent();
                            return [4 /*yield*/, peerConnection.setLocalDescription(answer)];
                        case 3:
                            _c.sent();
                            /* answer 전송 */
                            socket.emit(socket_message_1.RTC_MESSAGE.ANSWER, { receiveId: senderId, answer: answer });
                            return [2 /*return*/];
                    }
                });
            });
        });
        /* answer 받기 */
        socket.on(socket_message_1.RTC_MESSAGE.ANSWER, function (_a) {
            var senderId = _a.senderId, answer = _a.answer;
            return __awaiter(_this, void 0, void 0, function () {
                var peerConnection;
                var _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            peerConnection = (_b = peerConnectionRef === null || peerConnectionRef === void 0 ? void 0 : peerConnectionRef.current) === null || _b === void 0 ? void 0 : _b[senderId];
                            if (!peerConnection) {
                                return [2 /*return*/, console.log("Peer Connection does not exist")];
                            }
                            return [4 /*yield*/, peerConnection.setRemoteDescription(answer)];
                        case 1:
                            _c.sent();
                            return [2 /*return*/];
                    }
                });
            });
        });
        /* ice candidate */
        socket.on(socket_message_1.RTC_MESSAGE.ICE_CANDIDATE, function (_a) {
            var senderId = _a.senderId, candidate = _a.candidate;
            return __awaiter(_this, void 0, void 0, function () {
                var peerConnection;
                var _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            peerConnection = (_b = peerConnectionRef === null || peerConnectionRef === void 0 ? void 0 : peerConnectionRef.current) === null || _b === void 0 ? void 0 : _b[senderId];
                            if (!peerConnection) {
                                return [2 /*return*/, console.log("Peer Connection does not exist")];
                            }
                            return [4 /*yield*/, peerConnection.addIceCandidate(candidate)];
                        case 1:
                            _c.sent();
                            return [2 /*return*/];
                    }
                });
            });
        });
        /* disconnected */
        socket.on(socket_message_1.RTC_MESSAGE.DISCONNECTED, function (senderId) {
            var _a;
            (_a = peerConnectionRef === null || peerConnectionRef === void 0 ? void 0 : peerConnectionRef.current) === null || _a === void 0 ? true : delete _a[senderId];
            setParticipants(function (prev) {
                var newState = new Map(prev);
                newState.delete(senderId);
                return newState;
            });
        });
    }, []);
    return participants;
}
exports.default = useRTC;
